
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Release
;Chip type              : ATmega16A
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega16A
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _minute=R4
	.DEF _minute_msb=R5
	.DEF _hour=R6
	.DEF _hour_msb=R7
	.DEF _second=R8
	.DEF _second_msb=R9
	.DEF _ontime=R10
	.DEF _ontime_msb=R11
	.DEF _offtime=R12
	.DEF _offtime_msb=R13

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_keytbl:
	.DB  0x77,0x7B,0x7D,0xB7,0xBB,0xBD,0xD7,0xDB
	.DB  0xDD,0xEB,0xE7,0xED,0x7E,0xBE,0xDE,0xEE

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0001

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x63,0x0,0x63,0x0

_0x3:
	.DB  0x2
_0x4:
	.DB  0x63
_0x5:
	.DB  0x63
_0x0:
	.DB  0x4C,0x6F,0x61,0x64,0x69,0x6E,0x67,0x2E
	.DB  0x2E,0x2E,0x0,0x20,0x0,0x48,0x3D,0x25
	.DB  0x64,0x25,0x25,0x0,0x25,0x64,0x3A,0x25
	.DB  0x64,0x3A,0x25,0x64,0x20,0x54,0x3D,0x25
	.DB  0x64,0x25,0x63,0x43,0x20,0x0,0x47,0x3D
	.DB  0x48,0x0,0x47,0x3D,0x4E,0x0,0x4C,0x3D
	.DB  0x4E,0x0,0x4C,0x3D,0x59,0x0,0x25,0x64
	.DB  0x0,0x20,0x20,0x0,0x73,0x65,0x74,0x20
	.DB  0x73,0x79,0x73,0x74,0x65,0x6D,0x20,0x54
	.DB  0x69,0x6D,0x65,0x0,0x3F,0x3F,0x3A,0x25
	.DB  0x64,0x3A,0x25,0x64,0x0,0x25,0x64,0x3A
	.DB  0x3F,0x3F,0x3A,0x25,0x64,0x0,0x4F,0x4E
	.DB  0x20,0x4F,0x46,0x46,0x20,0x54,0x69,0x6D
	.DB  0x65,0x72,0x3F,0x20,0x0,0x2A,0x4F,0x4E
	.DB  0x3D,0x31,0x20,0x4F,0x46,0x46,0x3D,0x32
	.DB  0x2A,0x0,0x4F,0x4E,0x20,0x54,0x69,0x6D
	.DB  0x65,0x20,0x4D,0x69,0x6E,0x75,0x74,0x65
	.DB  0x3A,0x20,0x0,0x4F,0x46,0x46,0x20,0x54
	.DB  0x69,0x6D,0x65,0x20,0x4D,0x69,0x6E,0x75
	.DB  0x74,0x65,0x3A,0x0,0x65,0x6E,0x74,0x65
	.DB  0x72,0x20,0x4D,0x61,0x78,0x20,0x54,0x65
	.DB  0x6D,0x70,0x20,0x3F,0x0,0x4D,0x61,0x78
	.DB  0x20,0x74,0x65,0x6D,0x70,0x3D,0x25,0x64
	.DB  0x20,0x43,0x0,0x65,0x6E,0x74,0x65,0x72
	.DB  0x20,0x6D,0x69,0x6E,0x20,0x54,0x65,0x6D
	.DB  0x70,0x20,0x3F,0x0,0x6D,0x69,0x6E,0x20
	.DB  0x74,0x65,0x6D,0x70,0x3D,0x25,0x64,0x20
	.DB  0x43,0x0,0x65,0x6E,0x74,0x65,0x72,0x20
	.DB  0x6D,0x69,0x6E,0x20,0x68,0x75,0x6D,0x69
	.DB  0x64,0x3F,0x0,0x6D,0x69,0x6E,0x20,0x68
	.DB  0x75,0x6D,0x69,0x64,0x3D,0x25,0x2E,0x30
	.DB  0x66,0x25,0x25,0x0,0x65,0x6E,0x74,0x65
	.DB  0x72,0x20,0x43,0x6F,0x32,0x20,0x72,0x61
	.DB  0x6E,0x67,0x65,0x3F,0x0,0x43,0x6F,0x32
	.DB  0x3D,0x5B,0x31,0x2D,0x39,0x39,0x5D,0x0
	.DB  0x43,0x6F,0x32,0x20,0x52,0x61,0x6E,0x67
	.DB  0x65,0x3D,0x25,0x64,0x20,0x0,0x65,0x6E
	.DB  0x74,0x65,0x72,0x20,0x4C,0x69,0x67,0x68
	.DB  0x74,0x20,0x72,0x61,0x6E,0x67,0x65,0x3F
	.DB  0x0,0x4C,0x69,0x67,0x68,0x74,0x3D,0x5B
	.DB  0x31,0x2D,0x39,0x39,0x5D,0x0,0x6C,0x69
	.DB  0x67,0x68,0x74,0x20,0x52,0x61,0x6E,0x67
	.DB  0x65,0x3D,0x25,0x64,0x20,0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x20A0060:
	.DB  0x1
_0x20A0000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x04
	.DW  0x0A
	.DW  __REG_VARS*2

	.DW  0x01
	.DW  _onoff_timer
	.DW  _0x3*2

	.DW  0x01
	.DW  _temp_ontime
	.DW  _0x4*2

	.DW  0x01
	.DW  _temp_offtime
	.DW  _0x5*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G105
	.DW  _0x20A0060*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega16a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;#include <delay.h>
;#include <stdio.h>
;#define ADC_VREF_TYPE 0x40
;#define xtal 8000000
;
;flash unsigned char keytbl[16]={0x77, 0x7B, 0x7D, 0xB7,
;  0xBB, 0xBD, 0xD7, 0xDB,
;   0xDD, 0xEB, 0xE7, 0xED,
;    0x7e,0xBE, 0xDE, 0xEE};
;
;  unsigned minute,hour,second;
;  unsigned ontime=99,offtime=99,onoff_timer=2;

	.DSEG
;  unsigned temp_ontime=99,temp_offtime=99;
;  bit count_ontime_now=1,count_offtime_now=0,water_flag=0;
;
; eeprom unsigned char t_max=30,t_min=20,light_range=80,co2_range=80;
; eeprom float h_min=20;
;
;
;//DHT11 DEFINES
;#define DHT11_PORT PORTA
;#define DHT11_PORTPIN PORTA1
;#define DHT11_DDR DDRA
;#define DHT11_DDRPIN DDA1
;#define DHT11_PINPORT PINA
;#define DHT11_PIN PINA1
;
;#define DHT11_INPUT_MODE() DHT11_DDR&=~(1<<DHT11_DDRPIN)
;#define DHT11_OUTPUT_MODE() DHT11_DDR|=(1<<DHT11_DDRPIN)
;#define DHT11_LOW() DHT11_PORT&=~(1<<DHT11_PORTPIN)
;#define DHT11_HIGH() DHT11_PORT|=(1<<DHT11_PORTPIN)
;
;#define DHTLIB_OK                               0
;#define DHTLIB_ERROR_CHECKSUM					-1
;#define DHTLIB_ERROR_TIMEOUT					-2
;
;
;//END OF DHT11 DEFINES
;
;    interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 002B     {

	.CSEG
_timer2_ovf_isr:
; .FSTART _timer2_ovf_isr
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002C        if(onoff_timer==1 && second==59){
	CALL SUBOPT_0x0
	SBIW R26,1
	BRNE _0x7
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CP   R30,R8
	CPC  R31,R9
	BREQ _0x8
_0x7:
	RJMP _0x6
_0x8:
; 0000 002D              if(  count_ontime_now==1 ){
	SBRS R2,0
	RJMP _0x9
; 0000 002E                temp_ontime--;
	LDI  R26,LOW(_temp_ontime)
	LDI  R27,HIGH(_temp_ontime)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 002F                water_flag=1;
	SET
	BLD  R2,2
; 0000 0030 
; 0000 0031               }
; 0000 0032 
; 0000 0033               if( count_offtime_now==1 ){
_0x9:
	SBRS R2,1
	RJMP _0xA
; 0000 0034               temp_offtime--;
	LDI  R26,LOW(_temp_offtime)
	LDI  R27,HIGH(_temp_offtime)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0035                water_flag=0;
	CLT
	BLD  R2,2
; 0000 0036 
; 0000 0037               }
; 0000 0038                 if(temp_ontime==0){
_0xA:
	LDS  R30,_temp_ontime
	LDS  R31,_temp_ontime+1
	SBIW R30,0
	BRNE _0xB
; 0000 0039                    temp_ontime=ontime;
	__PUTWMRN _temp_ontime,0,10,11
; 0000 003A                    count_ontime_now=0;
	CLT
	BLD  R2,0
; 0000 003B                    count_offtime_now=1;
	SET
	BLD  R2,1
; 0000 003C                    water_flag=0;
	CLT
	BLD  R2,2
; 0000 003D                    }
; 0000 003E                      if(temp_offtime==0){
_0xB:
	LDS  R30,_temp_offtime
	LDS  R31,_temp_offtime+1
	SBIW R30,0
	BRNE _0xC
; 0000 003F                    temp_offtime=offtime;
	__PUTWMRN _temp_offtime,0,12,13
; 0000 0040                    count_ontime_now=1;
	SET
	BLD  R2,0
; 0000 0041                    count_offtime_now=0;
	CLT
	BLD  R2,1
; 0000 0042                    water_flag=1;
	SET
	BLD  R2,2
; 0000 0043                    }
; 0000 0044           }
_0xC:
; 0000 0045 
; 0000 0046 
; 0000 0047     if(second==59){  //Real Time function Code
_0x6:
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CP   R30,R8
	CPC  R31,R9
	BRNE _0xD
; 0000 0048       second=0;
	CLR  R8
	CLR  R9
; 0000 0049       if(minute==59){
	CP   R30,R4
	CPC  R31,R5
	BRNE _0xE
; 0000 004A       minute=0;
	CLR  R4
	CLR  R5
; 0000 004B       if(hour==23)
	LDI  R30,LOW(23)
	LDI  R31,HIGH(23)
	CP   R30,R6
	CPC  R31,R7
	BRNE _0xF
; 0000 004C       hour=0;
	CLR  R6
	CLR  R7
; 0000 004D       else
	RJMP _0x10
_0xF:
; 0000 004E       hour++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
; 0000 004F       }
_0x10:
; 0000 0050       else
	RJMP _0x11
_0xE:
; 0000 0051       minute++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
; 0000 0052       }
_0x11:
; 0000 0053       else
	RJMP _0x12
_0xD:
; 0000 0054       second++; //End of Real Time function Code
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 0055 
; 0000 0056 
; 0000 0057      }
_0x12:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
; .FEND
;
;
; void setting(void);
; void timer_setting(void);
; void system_setting(void);
; unsigned char get_keypad(void);
; unsigned char get_number(void);
; int read_dht11(int *temp,int *humidity); // DHT11 READ FUNC
;  unsigned int read_adc(unsigned char adc_input)
; 0000 0061   {
_read_adc:
; .FSTART _read_adc
; 0000 0062   ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
	ST   -Y,R26
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
; 0000 0063   delay_us(10);
	__DELAY_USB 27
; 0000 0064   ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0065   while ((ADCSRA & 0x10)==0);
_0x13:
	SBIS 0x6,4
	RJMP _0x13
; 0000 0066   ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0067   return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	JMP  _0x20C0007
; 0000 0068   }
; .FEND
;
;  void main(void){
; 0000 006A void main(void){
_main:
; .FSTART _main
; 0000 006B   unsigned char lcd_buff_1[17],lcd_buff_2[17];
; 0000 006C 
; 0000 006D unsigned int co2;
; 0000 006E unsigned char count_loop=0;
; 0000 006F 
; 0000 0070 int temp=0;
; 0000 0071 int humidity=0;
; 0000 0072 int status=0;
; 0000 0073 
; 0000 0074 unsigned int ldr_light;
; 0000 0075 
; 0000 0076 
; 0000 0077   DDRC=0X1F; // BUZZER & RELAYS
	SBIW R28,40
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+3,R30
	STD  Y+4,R30
	STD  Y+5,R30
;	lcd_buff_1 -> Y+23
;	lcd_buff_2 -> Y+6
;	co2 -> R16,R17
;	count_loop -> R19
;	temp -> R20,R21
;	humidity -> Y+4
;	status -> Y+2
;	ldr_light -> Y+0
	LDI  R19,0
	__GETWRN 20,21,0
	LDI  R30,LOW(31)
	OUT  0x14,R30
; 0000 0078 
; 0000 0079   lcd_init(16);
	LDI  R26,LOW(16)
	CALL _lcd_init
; 0000 007A   lcd_putsf("Loading...");
	__POINTW2FN _0x0,0
	CALL SUBOPT_0x1
; 0000 007B   delay_ms(1);
; 0000 007C   lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 007D   lcd_putsf(" ");
	__POINTW2FN _0x0,11
	CALL _lcd_putsf
; 0000 007E    delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL _delay_ms
; 0000 007F   ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	OUT  0x7,R30
; 0000 0080   ADCSRA=0x83;
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 0081 
; 0000 0082   ASSR=0x08;//timer2
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 0083   TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 0084   TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0085   OCR2=0x00;
	OUT  0x23,R30
; 0000 0086   TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 0087   #asm("sei")
	sei
; 0000 0088 
; 0000 0089       //DHT11 needs 2000 ms to init
; 0000 008A       delay_ms(2000);//Init DHT11
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	CALL _delay_ms
; 0000 008B       read_dht11(&temp,&humidity);
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	PUSH R20
	MOVW R26,R28
	ADIW R26,6
	RCALL _read_dht11
	POP  R20
	POP  R21
; 0000 008C 
; 0000 008D      PORTC.4=1; //buzer test
	SBI  0x15,4
; 0000 008E      delay_ms(200);
	LDI  R26,LOW(200)
	LDI  R27,0
	CALL _delay_ms
; 0000 008F      PORTC.4=0;
	CBI  0x15,4
; 0000 0090      lcd_clear();
	CALL _lcd_clear
; 0000 0091 
; 0000 0092        while(1){
_0x1A:
; 0000 0093        /*just for dht*/
; 0000 0094        delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	CALL _delay_ms
; 0000 0095        count_loop++;
	SUBI R19,-1
; 0000 0096        if(count_loop==20){ //every 2second read DHT11
	CPI  R19,20
	BRNE _0x1D
; 0000 0097        status=read_dht11(&temp,&humidity);
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	PUSH R20
	MOVW R26,R28
	ADIW R26,6
	RCALL _read_dht11
	POP  R20
	POP  R21
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 0098        count_loop=0;
	LDI  R19,LOW(0)
; 0000 0099        }
; 0000 009A        /*end of dht section in loop*/
; 0000 009B        ldr_light=read_adc(2);
_0x1D:
	LDI  R26,LOW(2)
	RCALL _read_adc
	ST   Y,R30
	STD  Y+1,R31
; 0000 009C        co2=read_adc(0);
	LDI  R26,LOW(0)
	RCALL _read_adc
	MOVW R16,R30
; 0000 009D 
; 0000 009E       sprintf(lcd_buff_2,"H=%d%%",humidity,ldr_light);
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,13
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL __CWD1
	CALL __PUTPARD1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
; 0000 009F 
; 0000 00A0       sprintf(lcd_buff_1,"%d:%d:%d T=%d%cC ",hour,minute,second,(temp),223);
	MOVW R30,R28
	ADIW R30,23
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,20
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R6
	CALL SUBOPT_0x3
	MOVW R30,R4
	CALL SUBOPT_0x3
	MOVW R30,R8
	CALL SUBOPT_0x3
	MOVW R30,R20
	CALL __CWD1
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	LDI  R24,20
	CALL _sprintf
	ADIW R28,24
; 0000 00A1 
; 0000 00A2       lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
; 0000 00A3       lcd_puts(lcd_buff_1);
	MOVW R26,R28
	ADIW R26,23
	CALL _lcd_puts
; 0000 00A4       delay_us(20);
	__DELAY_USB 53
; 0000 00A5       lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 00A6       lcd_puts(lcd_buff_2);
	MOVW R26,R28
	ADIW R26,6
	CALL _lcd_puts
; 0000 00A7       delay_us(20);
	__DELAY_USB 53
; 0000 00A8 
; 0000 00A9 
; 0000 00AA 
; 0000 00AB 
; 0000 00AC 
; 0000 00AD 
; 0000 00AE            if(humidity<h_min || water_flag==1 ){
	LDI  R26,LOW(_h_min)
	LDI  R27,HIGH(_h_min)
	CALL __EEPROMRDD
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __CWD2
	CALL __CDF2
	CALL __CMPF12
	BRLO _0x1F
	SBRS R2,2
	RJMP _0x1E
_0x1F:
; 0000 00AF                PORTC.0=1;
	SBI  0x15,0
; 0000 00B0              }
; 0000 00B1                else {
	RJMP _0x23
_0x1E:
; 0000 00B2                PORTC.0=0;
	CBI  0x15,0
; 0000 00B3               }
_0x23:
; 0000 00B4 
; 0000 00B5 
; 0000 00B6 
; 0000 00B7            if(co2> (unsigned int)(co2_range*10) ){
	CALL SUBOPT_0x5
	BRSH _0x26
; 0000 00B8             lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x6
; 0000 00B9             lcd_putsf("G=H");
	__POINTW2FN _0x0,38
	CALL _lcd_putsf
; 0000 00BA 
; 0000 00BB             PORTC.4=1; //buzzer on
	SBI  0x15,4
; 0000 00BC              }
; 0000 00BD              else{
	RJMP _0x29
_0x26:
; 0000 00BE              lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x6
; 0000 00BF              lcd_putsf("G=N");
	__POINTW2FN _0x0,42
	CALL _lcd_putsf
; 0000 00C0              PORTC.4=0;
	CBI  0x15,4
; 0000 00C1              }
_0x29:
; 0000 00C2 
; 0000 00C3 
; 0000 00C4              if( ( (temp/2)>t_max) || (co2> (unsigned int)(co2_range*10)) ) {
	CALL SUBOPT_0x7
	LDI  R26,LOW(_t_max)
	LDI  R27,HIGH(_t_max)
	CALL __EEPROMRDB
	MOVW R26,R0
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x2D
	CALL SUBOPT_0x5
	BRSH _0x2C
_0x2D:
; 0000 00C5                PORTC.1=1;  // fan on
	SBI  0x15,1
; 0000 00C6              }
; 0000 00C7                else {
	RJMP _0x31
_0x2C:
; 0000 00C8                PORTC.1=0;
	CBI  0x15,1
; 0000 00C9               }
_0x31:
; 0000 00CA 
; 0000 00CB                if((temp/2)<t_min){
	CALL SUBOPT_0x7
	LDI  R26,LOW(_t_min)
	LDI  R27,HIGH(_t_min)
	CALL __EEPROMRDB
	MOVW R26,R0
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x34
; 0000 00CC                PORTC.2=1; //heater on
	SBI  0x15,2
; 0000 00CD              }
; 0000 00CE                else {
	RJMP _0x37
_0x34:
; 0000 00CF                PORTC.2=0; // Heater off
	CBI  0x15,2
; 0000 00D0               }
_0x37:
; 0000 00D1 
; 0000 00D2 
; 0000 00D3 
; 0000 00D4              if(ldr_light>(unsigned int)(light_range*10)){
	LDI  R26,LOW(_light_range)
	LDI  R27,HIGH(_light_range)
	CALL __EEPROMRDB
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	LD   R26,Y
	LDD  R27,Y+1
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x3A
; 0000 00D5                PORTC.3=1;
	SBI  0x15,3
; 0000 00D6                lcd_gotoxy(7,1);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x6
; 0000 00D7              lcd_putsf("L=N");
	__POINTW2FN _0x0,46
	RJMP _0x8D
; 0000 00D8              }
; 0000 00D9                else {
_0x3A:
; 0000 00DA                PORTC.3=0;
	CBI  0x15,3
; 0000 00DB                lcd_gotoxy(7,1);
	LDI  R30,LOW(7)
	CALL SUBOPT_0x6
; 0000 00DC                lcd_putsf("L=Y");
	__POINTW2FN _0x0,50
_0x8D:
	CALL _lcd_putsf
; 0000 00DD               }
; 0000 00DE 
; 0000 00DF              if(get_keypad()==13){
	RCALL _get_keypad
	CPI  R30,LOW(0xD)
	BRNE _0x40
; 0000 00E0              setting();
	RCALL _setting
; 0000 00E1              }
; 0000 00E2 
; 0000 00E3              if(get_keypad()==14){  //timer setting
_0x40:
	RCALL _get_keypad
	CPI  R30,LOW(0xE)
	BRNE _0x41
; 0000 00E4               timer_setting();
	RCALL _timer_setting
; 0000 00E5              }
; 0000 00E6 
; 0000 00E7               if(get_keypad()==15){
_0x41:
	RCALL _get_keypad
	CPI  R30,LOW(0xF)
	BRNE _0x42
; 0000 00E8              system_setting();
	RCALL _system_setting
; 0000 00E9              }
; 0000 00EA 
; 0000 00EB 
; 0000 00EC 
; 0000 00ED 
; 0000 00EE 
; 0000 00EF 
; 0000 00F0 
; 0000 00F1 
; 0000 00F2        }
_0x42:
	RJMP _0x1A
; 0000 00F3 
; 0000 00F4 
; 0000 00F5 
; 0000 00F6 
; 0000 00F7 
; 0000 00F8 
; 0000 00F9 }
_0x43:
	RJMP _0x43
; .FEND
;
;
;  ////get keypad /
;  unsigned char get_keypad(void){
; 0000 00FD unsigned char get_keypad(void){
_get_keypad:
; .FSTART _get_keypad
; 0000 00FE   unsigned char key, butnum;
; 0000 00FF 
; 0000 0100   DDRB = 0x0f;
	ST   -Y,R17
	ST   -Y,R16
;	key -> R17
;	butnum -> R16
	LDI  R30,LOW(15)
	OUT  0x17,R30
; 0000 0101   PORTB = 0xf0;
	LDI  R30,LOW(240)
	OUT  0x18,R30
; 0000 0102   delay_us(5);
	__DELAY_USB 13
; 0000 0103   key = PINB;
	IN   R17,22
; 0000 0104   DDRB = 0xf0;
	OUT  0x17,R30
; 0000 0105   PORTB = 0x0f;
	LDI  R30,LOW(15)
	OUT  0x18,R30
; 0000 0106   delay_us(5);
	__DELAY_USB 13
; 0000 0107   key = key | PINB;
	IN   R30,0x16
	OR   R17,R30
; 0000 0108   delay_us(5);
	__DELAY_USB 13
; 0000 0109 
; 0000 010A     if (key != 0xff)
	CPI  R17,255
	BREQ _0x44
; 0000 010B    {
; 0000 010C      for (butnum=0; butnum<16; butnum++) {
	LDI  R16,LOW(0)
_0x46:
	CPI  R16,16
	BRSH _0x47
; 0000 010D      if (keytbl[butnum]==key) break;
	MOV  R30,R16
	LDI  R31,0
	SUBI R30,LOW(-_keytbl*2)
	SBCI R31,HIGH(-_keytbl*2)
	LPM  R26,Z
	CP   R17,R26
	BREQ _0x47
; 0000 010E     }
	SUBI R16,-1
	RJMP _0x46
_0x47:
; 0000 010F 
; 0000 0110     butnum++;
	SUBI R16,-1
; 0000 0111     }
; 0000 0112    else butnum=100;
	RJMP _0x49
_0x44:
	LDI  R16,LOW(100)
; 0000 0113    return butnum;
_0x49:
	MOV  R30,R16
	LD   R16,Y+
	LD   R17,Y+
	RET
; 0000 0114   } ////end get keypad f
; .FEND
;
;
;
;
;
;  ///get num
;  unsigned char get_number(void){  // get 2digit
; 0000 011B unsigned char get_number(void){
_get_number:
; .FSTART _get_number
; 0000 011C    unsigned char z,x,y,buff[16];  // x is first num y is second and then our num=(x*10)+y
; 0000 011D    aval:
	SBIW R28,16
	CALL __SAVELOCR4
;	z -> R17
;	x -> R16
;	y -> R19
;	buff -> Y+4
_0x4A:
; 0000 011E   do{
_0x4C:
; 0000 011F    x=get_keypad();
	RCALL _get_keypad
	MOV  R16,R30
; 0000 0120    if(x==10){x=0;}
	CPI  R16,10
	BRNE _0x4E
	LDI  R16,LOW(0)
; 0000 0121    if(x>10){x=100;}
_0x4E:
	CPI  R16,11
	BRLO _0x4F
	LDI  R16,LOW(100)
; 0000 0122    }while(x==100);
_0x4F:
	CPI  R16,100
	BREQ _0x4C
; 0000 0123 
; 0000 0124    do{
_0x51:
; 0000 0125    z=get_keypad();
	RCALL _get_keypad
	MOV  R17,R30
; 0000 0126    }while(z !=100);
	CPI  R17,100
	BRNE _0x51
; 0000 0127 
; 0000 0128    delay_ms(40);
	LDI  R26,LOW(40)
	LDI  R27,0
	CALL _delay_ms
; 0000 0129    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 012A    sprintf(buff,"%d",x);
	CALL SUBOPT_0x8
; 0000 012B    lcd_puts(buff);
; 0000 012C    delay_ms(40);
	LDI  R26,LOW(40)
	LDI  R27,0
	CALL _delay_ms
; 0000 012D 
; 0000 012E    do{
_0x54:
; 0000 012F    y=get_keypad();
	RCALL _get_keypad
	MOV  R19,R30
; 0000 0130    if(y==10){y=0;}
	CPI  R19,10
	BRNE _0x56
	LDI  R19,LOW(0)
; 0000 0131    if(y>12){y=100;}
_0x56:
	CPI  R19,13
	BRLO _0x57
	LDI  R19,LOW(100)
; 0000 0132    }while(y==100);
_0x57:
	CPI  R19,100
	BREQ _0x54
; 0000 0133 
; 0000 0134    do{
_0x59:
; 0000 0135    z=get_keypad();
	RCALL _get_keypad
	MOV  R17,R30
; 0000 0136    }while(z !=100);
	CPI  R17,100
	BRNE _0x59
; 0000 0137 
; 0000 0138    if(x<10){
	CPI  R16,10
	BRSH _0x5B
; 0000 0139     if(y<10){
	CPI  R19,10
	BRSH _0x5C
; 0000 013A     x*=10;
	LDI  R26,LOW(10)
	MULS R16,R26
	MOV  R16,R0
; 0000 013B     x=x+y;
	ADD  R16,R19
; 0000 013C     }
; 0000 013D    }
_0x5C:
; 0000 013E    lcd_gotoxy(0,1);
_0x5B:
	CALL SUBOPT_0x2
; 0000 013F    sprintf(buff,"%d",x);
	CALL SUBOPT_0x8
; 0000 0140    lcd_puts(buff);
; 0000 0141 
; 0000 0142    while(1){
_0x5D:
; 0000 0143    if(y==11){ return x;} //enter pressed
	CPI  R19,11
	BRNE _0x60
	MOV  R30,R16
	RJMP _0x20C000A
; 0000 0144    if(y==12){ //corect pressed
_0x60:
	CPI  R19,12
	BRNE _0x61
; 0000 0145    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 0146    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0147    goto aval;}
	RJMP _0x4A
; 0000 0148    y=get_keypad();
_0x61:
	RCALL _get_keypad
	MOV  R19,R30
; 0000 0149    }
	RJMP _0x5D
; 0000 014A   }
_0x20C000A:
	CALL __LOADLOCR4
	ADIW R28,20
	RET
; .FEND
;  ///setting
;  void setting(void){
; 0000 014C void setting(void){
_setting:
; .FSTART _setting
; 0000 014D   unsigned char buff[16];
; 0000 014E   lcd_clear();
	SBIW R28,16
;	buff -> Y+0
	CALL SUBOPT_0xA
; 0000 014F   lcd_putsf("set system Time");
; 0000 0150   lcd_gotoxy(5,1);
; 0000 0151   sprintf(buff,"??:%d:%d",minute,second);
	CALL SUBOPT_0xB
	__POINTW1FN _0x0,76
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R4
	CALL SUBOPT_0x3
	MOVW R30,R8
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
; 0000 0152   lcd_puts(buff);
	CALL SUBOPT_0xC
; 0000 0153    do{
_0x63:
; 0000 0154    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 0155    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0156    hour=get_number();
	RCALL _get_number
	MOV  R6,R30
	CLR  R7
; 0000 0157    }while(hour>23);
	LDI  R30,LOW(23)
	LDI  R31,HIGH(23)
	CP   R30,R6
	CPC  R31,R7
	BRLO _0x63
; 0000 0158    lcd_clear();
	CALL SUBOPT_0xA
; 0000 0159 
; 0000 015A   lcd_putsf("set system Time");
; 0000 015B   lcd_gotoxy(5,1);
; 0000 015C   sprintf(buff,"%d:??:%d",hour,second);
	CALL SUBOPT_0xB
	__POINTW1FN _0x0,85
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R6
	CALL SUBOPT_0x3
	MOVW R30,R8
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
; 0000 015D   lcd_puts(buff);
	CALL SUBOPT_0xC
; 0000 015E    do{
_0x66:
; 0000 015F    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 0160    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0161    minute=get_number();
	RCALL _get_number
	MOV  R4,R30
	CLR  R5
; 0000 0162    }while(minute>59);
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CP   R30,R4
	CPC  R31,R5
	BRLO _0x66
; 0000 0163    lcd_clear();
	RCALL _lcd_clear
; 0000 0164 
; 0000 0165 
; 0000 0166 
; 0000 0167 
; 0000 0168   }
	JMP  _0x20C0006
; .FEND
;
;  void timer_setting(void){
; 0000 016A void timer_setting(void){
_timer_setting:
; .FSTART _timer_setting
; 0000 016B       unsigned char buff[16];
; 0000 016C        lcd_clear();
	SBIW R28,16
;	buff -> Y+0
	RCALL _lcd_clear
; 0000 016D   lcd_putsf("ON OFF Timer? ");
	__POINTW2FN _0x0,94
	CALL SUBOPT_0x1
; 0000 016E   delay_ms(1);
; 0000 016F   lcd_gotoxy(5,1);
	LDI  R30,LOW(5)
	CALL SUBOPT_0x6
; 0000 0170   lcd_putsf("*ON=1 OFF=2*");
	__POINTW2FN _0x0,109
	CALL _lcd_putsf
; 0000 0171 
; 0000 0172    do{
_0x69:
; 0000 0173    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 0174    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0175    onoff_timer=get_number();
	RCALL _get_number
	LDI  R31,0
	STS  _onoff_timer,R30
	STS  _onoff_timer+1,R31
; 0000 0176    }while(onoff_timer>2);
	CALL SUBOPT_0x0
	SBIW R26,3
	BRSH _0x69
; 0000 0177    lcd_clear();
	RCALL _lcd_clear
; 0000 0178 
; 0000 0179 
; 0000 017A    lcd_clear();
	RCALL _lcd_clear
; 0000 017B   lcd_putsf("ON Time Minute: ");
	__POINTW2FN _0x0,122
	CALL _lcd_putsf
; 0000 017C   lcd_puts(buff);
	CALL SUBOPT_0xC
; 0000 017D    do{
_0x6C:
; 0000 017E    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 017F    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0180    ontime=get_number();
	RCALL _get_number
	MOV  R10,R30
	CLR  R11
; 0000 0181    }while(ontime>99);
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	CP   R30,R10
	CPC  R31,R11
	BRLO _0x6C
; 0000 0182    lcd_clear();
	RCALL _lcd_clear
; 0000 0183 
; 0000 0184   lcd_putsf("OFF Time Minute:");
	__POINTW2FN _0x0,139
	CALL _lcd_putsf
; 0000 0185   lcd_puts(buff);
	CALL SUBOPT_0xC
; 0000 0186    do{
_0x6F:
; 0000 0187    lcd_gotoxy(0,1);
	CALL SUBOPT_0x2
; 0000 0188    lcd_putsf("  ");
	CALL SUBOPT_0x9
; 0000 0189    offtime=get_number();
	RCALL _get_number
	MOV  R12,R30
	CLR  R13
; 0000 018A    }while(offtime>99);
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	CP   R30,R12
	CPC  R31,R13
	BRLO _0x6F
; 0000 018B    lcd_clear();
	RCALL _lcd_clear
; 0000 018C 
; 0000 018D    temp_ontime=ontime;
	__PUTWMRN _temp_ontime,0,10,11
; 0000 018E    temp_offtime=offtime;
	__PUTWMRN _temp_offtime,0,12,13
; 0000 018F     if(onoff_timer==1)
	CALL SUBOPT_0x0
	SBIW R26,1
	BRNE _0x71
; 0000 0190      water_flag=1;
	SET
	RJMP _0x8E
; 0000 0191      else
_0x71:
; 0000 0192      water_flag=0;
	CLT
_0x8E:
	BLD  R2,2
; 0000 0193   }
	JMP  _0x20C0006
; .FEND
;
;  void system_setting(void)
; 0000 0196   {
_system_setting:
; .FSTART _system_setting
; 0000 0197   unsigned char lcd_buff_1[17] ;
; 0000 0198   lcd_clear();
	SBIW R28,17
;	lcd_buff_1 -> Y+0
	RCALL _lcd_clear
; 0000 0199    lcd_putsf("enter Max Temp ?");
	__POINTW2FN _0x0,156
	CALL SUBOPT_0xD
; 0000 019A    t_max=get_number();
	LDI  R26,LOW(_t_max)
	LDI  R27,HIGH(_t_max)
	CALL SUBOPT_0xE
; 0000 019B    lcd_clear();
; 0000 019C    sprintf(lcd_buff_1,"Max temp=%d C",t_max);
	__POINTW1FN _0x0,173
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_t_max)
	LDI  R27,HIGH(_t_max)
	CALL SUBOPT_0xF
; 0000 019D    lcd_puts(lcd_buff_1);
; 0000 019E    delay_ms(300);
	CALL SUBOPT_0x10
; 0000 019F 
; 0000 01A0    lcd_clear();
; 0000 01A1    lcd_putsf("enter min Temp ?");
	__POINTW2FN _0x0,187
	CALL SUBOPT_0xD
; 0000 01A2    t_min=get_number();
	LDI  R26,LOW(_t_min)
	LDI  R27,HIGH(_t_min)
	CALL SUBOPT_0xE
; 0000 01A3    lcd_clear();
; 0000 01A4    sprintf(lcd_buff_1,"min temp=%d C",t_min);
	__POINTW1FN _0x0,204
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_t_min)
	LDI  R27,HIGH(_t_min)
	CALL SUBOPT_0xF
; 0000 01A5    lcd_puts(lcd_buff_1);
; 0000 01A6    delay_ms(300);
	CALL SUBOPT_0x10
; 0000 01A7 
; 0000 01A8    lcd_clear();
; 0000 01A9    lcd_putsf("enter min humid?");
	__POINTW2FN _0x0,218
	CALL SUBOPT_0xD
; 0000 01AA    h_min=get_number();
	LDI  R26,LOW(_h_min)
	LDI  R27,HIGH(_h_min)
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __EEPROMWRD
; 0000 01AB    lcd_clear();
	RCALL _lcd_clear
; 0000 01AC    sprintf(lcd_buff_1,"min humid=%.0f%%",h_min);
	CALL SUBOPT_0xB
	__POINTW1FN _0x0,235
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_h_min)
	LDI  R27,HIGH(_h_min)
	CALL __EEPROMRDD
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 01AD    lcd_puts(lcd_buff_1);
	CALL SUBOPT_0xC
; 0000 01AE    delay_ms(300);
	CALL SUBOPT_0x10
; 0000 01AF 
; 0000 01B0    lcd_clear();
; 0000 01B1    lcd_putsf("enter Co2 range?");
	__POINTW2FN _0x0,252
	CALL SUBOPT_0x11
; 0000 01B2    delay_ms(1400);
; 0000 01B3    lcd_clear();
; 0000 01B4    lcd_putsf("Co2=[1-99]");
	__POINTW2FN _0x0,269
	CALL SUBOPT_0xD
; 0000 01B5    co2_range=get_number();
	LDI  R26,LOW(_co2_range)
	LDI  R27,HIGH(_co2_range)
	CALL SUBOPT_0xE
; 0000 01B6    lcd_clear();
; 0000 01B7    sprintf(lcd_buff_1,"Co2 Range=%d ",co2_range);
	__POINTW1FN _0x0,280
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_co2_range)
	LDI  R27,HIGH(_co2_range)
	CALL SUBOPT_0xF
; 0000 01B8    lcd_puts(lcd_buff_1);
; 0000 01B9    delay_ms(300);
	CALL SUBOPT_0x10
; 0000 01BA 
; 0000 01BB    lcd_clear();
; 0000 01BC    lcd_putsf("enter Light range?");
	__POINTW2FN _0x0,294
	CALL SUBOPT_0x11
; 0000 01BD    delay_ms(1400);
; 0000 01BE    lcd_clear();
; 0000 01BF    lcd_putsf("Light=[1-99]");
	__POINTW2FN _0x0,313
	CALL SUBOPT_0xD
; 0000 01C0    light_range=get_number();
	LDI  R26,LOW(_light_range)
	LDI  R27,HIGH(_light_range)
	CALL SUBOPT_0xE
; 0000 01C1    lcd_clear();
; 0000 01C2    sprintf(lcd_buff_1,"light Range=%d ",light_range);
	__POINTW1FN _0x0,326
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_light_range)
	LDI  R27,HIGH(_light_range)
	CALL SUBOPT_0xF
; 0000 01C3    lcd_puts(lcd_buff_1);
; 0000 01C4    delay_ms(300);
	LDI  R26,LOW(300)
	LDI  R27,HIGH(300)
	CALL _delay_ms
; 0000 01C5   }
	ADIW R28,17
	RET
; .FEND
;
;// read_dht11 functions
;int read_dht11(int *temp,int *humidity){
; 0000 01C8 int read_dht11(int *temp,int *humidity){
_read_dht11:
; .FSTART _read_dht11
; 0000 01C9 unsigned char bytes[5];
; 0000 01CA unsigned char sum;
; 0000 01CB unsigned int bitcount=8;
; 0000 01CC unsigned int loopcount=0;
; 0000 01CD unsigned int byteid=0;
; 0000 01CE int i=0;
; 0000 01CF // EMPTY BUFFER
; 0000 01D0     for (i=0; i< 5; i++) bytes[i] = 0;
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,9
	CALL SUBOPT_0x12
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+3,R30
	CALL __SAVELOCR6
;	*temp -> Y+17
;	*humidity -> Y+15
;	bytes -> Y+10
;	sum -> R17
;	bitcount -> R18,R19
;	loopcount -> R20,R21
;	byteid -> Y+8
;	i -> Y+6
	__GETWRN 18,19,8
	__GETWRN 20,21,0
	STD  Y+6,R30
	STD  Y+6+1,R30
_0x74:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRGE _0x75
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	MOVW R26,R28
	ADIW R26,10
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x74
_0x75:
; 0000 01D2 DDRA|=(1<<1       );
	SBI  0x1A,1
; 0000 01D3     DHT11_LOW();
	CBI  0x1B,1
; 0000 01D4     delay_ms(20);
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
; 0000 01D5     DHT11_HIGH();
	SBI  0x1B,1
; 0000 01D6     delay_us(2);
	__DELAY_USB 5
; 0000 01D7     DHT11_INPUT_MODE();
	CBI  0x1A,1
; 0000 01D8     DHT11_LOW();
	CBI  0x1B,1
; 0000 01D9     loopcount=0;
	__GETWRN 20,21,0
; 0000 01DA     while(!(DHT11_PINPORT&(1<<DHT11_PIN))){ //pin is low
_0x76:
	SBIC 0x19,1
	RJMP _0x78
; 0000 01DB      delay_us(40);
	__DELAY_USB 107
; 0000 01DC      loopcount++;
	__ADDWRN 20,21,1
; 0000 01DD     }
	RJMP _0x76
_0x78:
; 0000 01DE     if (loopcount>80) return DHTLIB_ERROR_TIMEOUT;
	__CPWRN 20,21,81
	BRLO _0x79
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RJMP _0x20C0009
; 0000 01DF     loopcount=0;
_0x79:
	__GETWRN 20,21,0
; 0000 01E0     while((DHT11_PINPORT&(1<<DHT11_PIN))){ //pin is high
_0x7A:
	SBIS 0x19,1
	RJMP _0x7C
; 0000 01E1      delay_us(1);
	__DELAY_USB 3
; 0000 01E2      loopcount++;
	__ADDWRN 20,21,1
; 0000 01E3     }
	RJMP _0x7A
_0x7C:
; 0000 01E4      if (loopcount>80) return DHTLIB_ERROR_TIMEOUT;
	__CPWRN 20,21,81
	BRLO _0x7D
	LDI  R30,LOW(65534)
	LDI  R31,HIGH(65534)
	RJMP _0x20C0009
; 0000 01E5     for(i=0;i<40;i++){
_0x7D:
	LDI  R30,LOW(0)
	STD  Y+6,R30
	STD  Y+6+1,R30
_0x7F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,40
	BRGE _0x80
; 0000 01E6     loopcount=0;
	__GETWRN 20,21,0
; 0000 01E7     while(!(DHT11_PINPORT&(1<<DHT11_PIN))){}
_0x81:
	SBIS 0x19,1
	RJMP _0x81
; 0000 01E8     while((DHT11_PINPORT&(1<<DHT11_PIN)) && loopcount<100){loopcount++;delay_us(1);}
_0x84:
	SBIS 0x19,1
	RJMP _0x87
	__CPWRN 20,21,100
	BRLO _0x88
_0x87:
	RJMP _0x86
_0x88:
	__ADDWRN 20,21,1
	__DELAY_USB 3
	RJMP _0x84
_0x86:
; 0000 01E9     if(loopcount>15)
	__CPWRN 20,21,16
	BRLO _0x89
; 0000 01EA     bytes[byteid] |= (1 << bitcount);
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	MOVW R26,R28
	ADIW R26,10
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LD   R1,Z
	MOV  R30,R18
	LDI  R26,LOW(1)
	CALL __LSLB12
	OR   R30,R1
	MOVW R26,R22
	ST   X,R30
; 0000 01EB      if (bitcount == 0)   // next byte?
_0x89:
	MOV  R0,R18
	OR   R0,R19
	BRNE _0x8A
; 0000 01EC         {
; 0000 01ED             bitcount = 7;    // restart at MSB
	__GETWRN 18,19,7
; 0000 01EE             byteid++;      // next byte!
	CALL SUBOPT_0x13
; 0000 01EF         }
; 0000 01F0         else bitcount--;
	RJMP _0x8B
_0x8A:
	__SUBWRN 18,19,1
; 0000 01F1     }
_0x8B:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x7F
_0x80:
; 0000 01F2     *humidity    = bytes[0];
	LDD  R30,Y+10
	LDD  R26,Y+15
	LDD  R27,Y+15+1
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
; 0000 01F3     *temp = bytes[2];
	LDD  R30,Y+12
	LDD  R26,Y+17
	LDD  R27,Y+17+1
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
; 0000 01F4     sum = (bytes[0] + bytes[1]+ bytes[2]+ bytes[3])&0xff;
	LDD  R30,Y+11
	LDD  R26,Y+10
	ADD  R30,R26
	LDD  R26,Y+12
	ADD  R30,R26
	LDD  R26,Y+13
	ADD  R26,R30
	MOV  R30,R26
	MOV  R17,R30
; 0000 01F5     if (bytes[4] != sum) return DHTLIB_ERROR_CHECKSUM;
	LDD  R26,Y+14
	CP   R17,R26
	BREQ _0x8C
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0009
; 0000 01F6     return DHTLIB_OK;
_0x8C:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20C0009:
	CALL __LOADLOCR6
	ADIW R28,19
	RET
; 0000 01F7 }
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
; .FSTART __lcd_write_nibble_G100
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0x12,3
	RJMP _0x2000005
_0x2000004:
	CBI  0x12,3
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x12,2
	RJMP _0x2000007
_0x2000006:
	CBI  0x12,2
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x12,1
	RJMP _0x2000009
_0x2000008:
	CBI  0x12,1
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0x12,0
	RJMP _0x200000B
_0x200000A:
	CBI  0x12,0
_0x200000B:
	__DELAY_USB 13
	SBI  0x12,4
	__DELAY_USB 13
	CBI  0x12,4
	__DELAY_USB 13
	RJMP _0x20C0007
; .FEND
__lcd_write_data:
; .FSTART __lcd_write_data
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RJMP _0x20C0007
; .FEND
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
; .FEND
_lcd_clear:
; .FSTART _lcd_clear
	LDI  R26,LOW(2)
	CALL SUBOPT_0x14
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	CALL SUBOPT_0x14
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
; .FEND
_lcd_putchar:
; .FSTART _lcd_putchar
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R26,__lcd_y
	SUBI R26,-LOW(1)
	STS  __lcd_y,R26
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20C0007
_0x2000013:
_0x2000010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x12,6
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x12,6
	RJMP _0x20C0007
; .FEND
_lcd_puts:
; .FSTART _lcd_puts
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	RJMP _0x20C0008
; .FEND
_lcd_putsf:
; .FSTART _lcd_putsf
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2000017:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000019
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2000017
_0x2000019:
_0x20C0008:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_lcd_init:
; .FSTART _lcd_init
	ST   -Y,R26
	SBI  0x11,3
	SBI  0x11,2
	SBI  0x11,1
	SBI  0x11,0
	SBI  0x11,4
	SBI  0x11,6
	SBI  0x11,5
	CBI  0x12,4
	CBI  0x12,6
	CBI  0x12,5
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
	CALL SUBOPT_0x15
	CALL SUBOPT_0x15
	CALL SUBOPT_0x15
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20C0007:
	ADIW R28,1
	RET
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
; .FSTART _put_buff_G101
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x16
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
_0x2020013:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2020014
	CALL SUBOPT_0x16
_0x2020014:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
; .FEND
__ftoe_G101:
; .FSTART __ftoe_G101
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,4
	CALL SUBOPT_0x12
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	CALL __SAVELOCR4
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x2020019
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2FN _0x2020000,0
	CALL _strcpyf
	RJMP _0x20C0005
_0x2020019:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x2020018
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW2FN _0x2020000,1
	CALL _strcpyf
	RJMP _0x20C0005
_0x2020018:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x202001B
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x202001B:
	LDD  R17,Y+11
_0x202001C:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x202001E
	CALL SUBOPT_0x17
	RJMP _0x202001C
_0x202001E:
	__GETD1S 12
	CALL __CPD10
	BRNE _0x202001F
	LDI  R19,LOW(0)
	CALL SUBOPT_0x17
	RJMP _0x2020020
_0x202001F:
	LDD  R19,Y+11
	CALL SUBOPT_0x18
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2020021
	CALL SUBOPT_0x17
_0x2020022:
	CALL SUBOPT_0x18
	BRLO _0x2020024
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
	RJMP _0x2020022
_0x2020024:
	RJMP _0x2020025
_0x2020021:
_0x2020026:
	CALL SUBOPT_0x18
	BRSH _0x2020028
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x1C
	SUBI R19,LOW(1)
	RJMP _0x2020026
_0x2020028:
	CALL SUBOPT_0x17
_0x2020025:
	__GETD1S 12
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x18
	BRLO _0x2020029
	CALL SUBOPT_0x19
	CALL SUBOPT_0x1A
_0x2020029:
_0x2020020:
	LDI  R17,LOW(0)
_0x202002A:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x202002C
	__GETD2S 4
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1D
	MOVW R26,R30
	MOVW R24,R22
	CALL _floor
	__PUTD1S 4
	CALL SUBOPT_0x19
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2S 4
	CALL __MULF12
	CALL SUBOPT_0x19
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x202002A
	CALL SUBOPT_0x1F
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x202002A
_0x202002C:
	CALL SUBOPT_0x13
	SBIW R30,1
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x202002E
	NEG  R19
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(45)
	RJMP _0x2020113
_0x202002E:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(43)
_0x2020113:
	ST   X,R30
	CALL SUBOPT_0x13
	CALL SUBOPT_0x13
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	CALL SUBOPT_0x13
	SBIW R30,1
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0005:
	CALL __LOADLOCR4
_0x20C0006:
	ADIW R28,16
	RET
; .FEND
__print_G101:
; .FSTART __print_G101
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,63
	SBIW R28,17
	CALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 88
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1SX 86
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020030:
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	CALL SUBOPT_0x16
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2020032
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2020036
	CPI  R18,37
	BRNE _0x2020037
	LDI  R17,LOW(1)
	RJMP _0x2020038
_0x2020037:
	CALL SUBOPT_0x22
_0x2020038:
	RJMP _0x2020035
_0x2020036:
	CPI  R30,LOW(0x1)
	BRNE _0x2020039
	CPI  R18,37
	BRNE _0x202003A
	CALL SUBOPT_0x22
	RJMP _0x2020114
_0x202003A:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x202003B
	LDI  R16,LOW(1)
	RJMP _0x2020035
_0x202003B:
	CPI  R18,43
	BRNE _0x202003C
	LDI  R30,LOW(43)
	STD  Y+21,R30
	RJMP _0x2020035
_0x202003C:
	CPI  R18,32
	BRNE _0x202003D
	LDI  R30,LOW(32)
	STD  Y+21,R30
	RJMP _0x2020035
_0x202003D:
	RJMP _0x202003E
_0x2020039:
	CPI  R30,LOW(0x2)
	BRNE _0x202003F
_0x202003E:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020040
	ORI  R16,LOW(128)
	RJMP _0x2020035
_0x2020040:
	RJMP _0x2020041
_0x202003F:
	CPI  R30,LOW(0x3)
	BRNE _0x2020042
_0x2020041:
	CPI  R18,48
	BRLO _0x2020044
	CPI  R18,58
	BRLO _0x2020045
_0x2020044:
	RJMP _0x2020043
_0x2020045:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2020035
_0x2020043:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2020046
	LDI  R17,LOW(4)
	RJMP _0x2020035
_0x2020046:
	RJMP _0x2020047
_0x2020042:
	CPI  R30,LOW(0x4)
	BRNE _0x2020049
	CPI  R18,48
	BRLO _0x202004B
	CPI  R18,58
	BRLO _0x202004C
_0x202004B:
	RJMP _0x202004A
_0x202004C:
	ORI  R16,LOW(32)
	LDI  R26,LOW(10)
	MUL  R20,R26
	MOV  R20,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2020035
_0x202004A:
_0x2020047:
	CPI  R18,108
	BRNE _0x202004D
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x2020035
_0x202004D:
	RJMP _0x202004E
_0x2020049:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0x2020035
_0x202004E:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2020053
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x23
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x25
	RJMP _0x2020054
_0x2020053:
	CPI  R30,LOW(0x45)
	BREQ _0x2020057
	CPI  R30,LOW(0x65)
	BRNE _0x2020058
_0x2020057:
	RJMP _0x2020059
_0x2020058:
	CPI  R30,LOW(0x66)
	BREQ PC+2
	RJMP _0x202005A
_0x2020059:
	MOVW R30,R28
	ADIW R30,22
	STD  Y+14,R30
	STD  Y+14+1,R31
	CALL SUBOPT_0x26
	CALL __GETD1P
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	LDD  R26,Y+13
	TST  R26
	BRMI _0x202005B
	LDD  R26,Y+21
	CPI  R26,LOW(0x2B)
	BREQ _0x202005D
	CPI  R26,LOW(0x20)
	BREQ _0x202005F
	RJMP _0x2020060
_0x202005B:
	CALL SUBOPT_0x29
	CALL __ANEGF1
	CALL SUBOPT_0x27
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x202005D:
	SBRS R16,7
	RJMP _0x2020061
	LDD  R30,Y+21
	ST   -Y,R30
	CALL SUBOPT_0x25
	RJMP _0x2020062
_0x2020061:
_0x202005F:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	SBIW R30,1
	LDD  R26,Y+21
	STD  Z+0,R26
_0x2020062:
_0x2020060:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0x2020064
	CALL SUBOPT_0x29
	CALL __PUTPARD1
	ST   -Y,R20
	LDD  R26,Y+19
	LDD  R27,Y+19+1
	CALL _ftoa
	RJMP _0x2020065
_0x2020064:
	CALL SUBOPT_0x29
	CALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	RCALL __ftoe_G101
_0x2020065:
	MOVW R30,R28
	ADIW R30,22
	CALL SUBOPT_0x2A
	RJMP _0x2020066
_0x202005A:
	CPI  R30,LOW(0x73)
	BRNE _0x2020068
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2A
	RJMP _0x2020069
_0x2020068:
	CPI  R30,LOW(0x70)
	BRNE _0x202006B
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2B
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020069:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x202006D
	CP   R20,R17
	BRLO _0x202006E
_0x202006D:
	RJMP _0x202006C
_0x202006E:
	MOV  R17,R20
_0x202006C:
_0x2020066:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+20,R30
	LDI  R19,LOW(0)
	RJMP _0x202006F
_0x202006B:
	CPI  R30,LOW(0x64)
	BREQ _0x2020072
	CPI  R30,LOW(0x69)
	BRNE _0x2020073
_0x2020072:
	ORI  R16,LOW(4)
	RJMP _0x2020074
_0x2020073:
	CPI  R30,LOW(0x75)
	BRNE _0x2020075
_0x2020074:
	LDI  R30,LOW(10)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x2020076
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x2C
	LDI  R17,LOW(10)
	RJMP _0x2020077
_0x2020076:
	__GETD1N 0x2710
	CALL SUBOPT_0x2C
	LDI  R17,LOW(5)
	RJMP _0x2020077
_0x2020075:
	CPI  R30,LOW(0x58)
	BRNE _0x2020079
	ORI  R16,LOW(8)
	RJMP _0x202007A
_0x2020079:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x20200B8
_0x202007A:
	LDI  R30,LOW(16)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x202007C
	__GETD1N 0x10000000
	CALL SUBOPT_0x2C
	LDI  R17,LOW(8)
	RJMP _0x2020077
_0x202007C:
	__GETD1N 0x1000
	CALL SUBOPT_0x2C
	LDI  R17,LOW(4)
_0x2020077:
	CPI  R20,0
	BREQ _0x202007D
	ANDI R16,LOW(127)
	RJMP _0x202007E
_0x202007D:
	LDI  R20,LOW(1)
_0x202007E:
	SBRS R16,1
	RJMP _0x202007F
	CALL SUBOPT_0x28
	CALL SUBOPT_0x26
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x2020115
_0x202007F:
	SBRS R16,2
	RJMP _0x2020081
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2B
	CALL __CWD1
	RJMP _0x2020115
_0x2020081:
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2B
	CLR  R22
	CLR  R23
_0x2020115:
	__PUTD1S 10
	SBRS R16,2
	RJMP _0x2020083
	LDD  R26,Y+13
	TST  R26
	BRPL _0x2020084
	CALL SUBOPT_0x29
	CALL __ANEGD1
	CALL SUBOPT_0x27
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2020084:
	LDD  R30,Y+21
	CPI  R30,0
	BREQ _0x2020085
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x2020086
_0x2020085:
	ANDI R16,LOW(251)
_0x2020086:
_0x2020083:
	MOV  R19,R20
_0x202006F:
	SBRC R16,0
	RJMP _0x2020087
_0x2020088:
	CP   R17,R21
	BRSH _0x202008B
	CP   R19,R21
	BRLO _0x202008C
_0x202008B:
	RJMP _0x202008A
_0x202008C:
	SBRS R16,7
	RJMP _0x202008D
	SBRS R16,2
	RJMP _0x202008E
	ANDI R16,LOW(251)
	LDD  R18,Y+21
	SUBI R17,LOW(1)
	RJMP _0x202008F
_0x202008E:
	LDI  R18,LOW(48)
_0x202008F:
	RJMP _0x2020090
_0x202008D:
	LDI  R18,LOW(32)
_0x2020090:
	CALL SUBOPT_0x22
	SUBI R21,LOW(1)
	RJMP _0x2020088
_0x202008A:
_0x2020087:
_0x2020091:
	CP   R17,R20
	BRSH _0x2020093
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2020094
	CALL SUBOPT_0x2D
	BREQ _0x2020095
	SUBI R21,LOW(1)
_0x2020095:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2020094:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL SUBOPT_0x25
	CPI  R21,0
	BREQ _0x2020096
	SUBI R21,LOW(1)
_0x2020096:
	SUBI R20,LOW(1)
	RJMP _0x2020091
_0x2020093:
	MOV  R19,R17
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x2020097
_0x2020098:
	CPI  R19,0
	BREQ _0x202009A
	SBRS R16,3
	RJMP _0x202009B
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LPM  R18,Z+
	STD  Y+14,R30
	STD  Y+14+1,R31
	RJMP _0x202009C
_0x202009B:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LD   R18,X+
	STD  Y+14,R26
	STD  Y+14+1,R27
_0x202009C:
	CALL SUBOPT_0x22
	CPI  R21,0
	BREQ _0x202009D
	SUBI R21,LOW(1)
_0x202009D:
	SUBI R19,LOW(1)
	RJMP _0x2020098
_0x202009A:
	RJMP _0x202009E
_0x2020097:
_0x20200A0:
	CALL SUBOPT_0x2E
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x20200A2
	SBRS R16,3
	RJMP _0x20200A3
	SUBI R18,-LOW(55)
	RJMP _0x20200A4
_0x20200A3:
	SUBI R18,-LOW(87)
_0x20200A4:
	RJMP _0x20200A5
_0x20200A2:
	SUBI R18,-LOW(48)
_0x20200A5:
	SBRC R16,4
	RJMP _0x20200A7
	CPI  R18,49
	BRSH _0x20200A9
	__GETD2S 16
	__CPD2N 0x1
	BRNE _0x20200A8
_0x20200A9:
	RJMP _0x20200AB
_0x20200A8:
	CP   R20,R19
	BRSH _0x2020116
	CP   R21,R19
	BRLO _0x20200AE
	SBRS R16,0
	RJMP _0x20200AF
_0x20200AE:
	RJMP _0x20200AD
_0x20200AF:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x20200B0
_0x2020116:
	LDI  R18,LOW(48)
_0x20200AB:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x20200B1
	CALL SUBOPT_0x2D
	BREQ _0x20200B2
	SUBI R21,LOW(1)
_0x20200B2:
_0x20200B1:
_0x20200B0:
_0x20200A7:
	CALL SUBOPT_0x22
	CPI  R21,0
	BREQ _0x20200B3
	SUBI R21,LOW(1)
_0x20200B3:
_0x20200AD:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x2E
	CALL __MODD21U
	CALL SUBOPT_0x27
	LDD  R30,Y+20
	__GETD2S 16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x2C
	__GETD1S 16
	CALL __CPD10
	BREQ _0x20200A1
	RJMP _0x20200A0
_0x20200A1:
_0x202009E:
	SBRS R16,0
	RJMP _0x20200B4
_0x20200B5:
	CPI  R21,0
	BREQ _0x20200B7
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x25
	RJMP _0x20200B5
_0x20200B7:
_0x20200B4:
_0x20200B8:
_0x2020054:
_0x2020114:
	LDI  R17,LOW(0)
_0x2020035:
	RJMP _0x2020030
_0x2020032:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,31
	RET
; .FEND
_sprintf:
; .FSTART _sprintf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x2F
	SBIW R30,0
	BRNE _0x20200B9
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0004
_0x20200B9:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x2F
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
; .FEND

	.CSEG

	.CSEG
_strcpyf:
; .FSTART _strcpyf
	ST   -Y,R27
	ST   -Y,R26
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
; .FEND
_strlen:
; .FSTART _strlen
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND

	.CSEG
_ftrunc:
; .FSTART _ftrunc
	CALL __PUTPARD2
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
; .FEND
_floor:
; .FSTART _floor
	CALL __PUTPARD2
	CALL __GETD2S0
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL __GETD1S0
	RJMP _0x20C0003
__floor1:
    brtc __floor0
	CALL __GETD1S0
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x20C0003:
	ADIW R28,4
	RET
; .FEND

	.CSEG
_ftoa:
; .FSTART _ftoa
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,4
	RCALL SUBOPT_0x12
	LDI  R30,LOW(0)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x20A000D
	RCALL SUBOPT_0x30
	__POINTW2FN _0x20A0000,0
	CALL _strcpyf
	RJMP _0x20C0002
_0x20A000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x20A000C
	RCALL SUBOPT_0x30
	__POINTW2FN _0x20A0000,1
	CALL _strcpyf
	RJMP _0x20C0002
_0x20A000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x20A000F
	__GETD1S 9
	CALL __ANEGF1
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x32
	LDI  R30,LOW(45)
	ST   X,R30
_0x20A000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x20A0010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x20A0010:
	LDD  R17,Y+8
_0x20A0011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x20A0013
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x34
	RJMP _0x20A0011
_0x20A0013:
	RCALL SUBOPT_0x35
	CALL __ADDF12
	RCALL SUBOPT_0x31
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	RCALL SUBOPT_0x34
_0x20A0014:
	RCALL SUBOPT_0x35
	CALL __CMPF12
	BRLO _0x20A0016
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x34
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x20A0017
	RCALL SUBOPT_0x30
	__POINTW2FN _0x20A0000,5
	CALL _strcpyf
	RJMP _0x20C0002
_0x20A0017:
	RJMP _0x20A0014
_0x20A0016:
	CPI  R17,0
	BRNE _0x20A0018
	RCALL SUBOPT_0x32
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x20A0019
_0x20A0018:
_0x20A001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x20A001C
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1D
	MOVW R26,R30
	MOVW R24,R22
	CALL _floor
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x35
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x20
	LDI  R31,0
	RCALL SUBOPT_0x33
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x31
	RJMP _0x20A001A
_0x20A001C:
_0x20A0019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20C0001
	RCALL SUBOPT_0x32
	LDI  R30,LOW(46)
	ST   X,R30
_0x20A001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x20A0020
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x31
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x20
	LDI  R31,0
	RCALL SUBOPT_0x36
	CALL __CWD1
	CALL __CDF1
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x31
	RJMP _0x20A001E
_0x20A0020:
_0x20C0001:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0002:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET
; .FEND

	.DSEG

	.CSEG

	.DSEG
_onoff_timer:
	.BYTE 0x2
_temp_ontime:
	.BYTE 0x2
_temp_offtime:
	.BYTE 0x2

	.ESEG
_t_max:
	.DB  0x1E
_t_min:
	.DB  0x14
_light_range:
	.DB  0x50
_co2_range:
	.DB  0x50
_h_min:
	.DB  0x0,0x0,0xA0,0x41

	.DSEG
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G105:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDS  R26,_onoff_timer
	LDS  R27,_onoff_timer+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	CALL _lcd_putsf
	LDI  R26,LOW(1)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x3:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(_co2_range)
	LDI  R27,HIGH(_co2_range)
	CALL __EEPROMRDB
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	CP   R30,R16
	CPC  R31,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	LDI  R26,LOW(1)
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	MOVW R26,R20
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	MOVW R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x8:
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,54
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	MOVW R26,R28
	ADIW R26,4
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9:
	__POINTW2FN _0x0,57
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	CALL _lcd_clear
	__POINTW2FN _0x0,60
	CALL _lcd_putsf
	LDI  R30,LOW(5)
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xC:
	MOVW R26,R28
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	CALL _lcd_putsf
	JMP  _get_number

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xE:
	CALL __EEPROMWRB
	CALL _lcd_clear
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:30 WORDS
SUBOPT_0xF:
	CALL __EEPROMRDB
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(300)
	LDI  R27,HIGH(300)
	CALL _delay_ms
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	CALL _lcd_putsf
	LDI  R26,LOW(1400)
	LDI  R27,HIGH(1400)
	CALL _delay_ms
	JMP  _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	CALL __lcd_write_data
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x15:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x17:
	__GETD2S 4
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x18:
	__GETD1S 4
	__GETD2S 12
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x19:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1A:
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__PUTD1S 12
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	__GETD2N 0x3F000000
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	CALL __SWAPD12
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x22:
	ST   -Y,R18
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x23:
	__GETW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x24:
	SBIW R30,4
	__PUTW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x25:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x26:
	__GETW2SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	__PUTD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x28:
	RCALL SUBOPT_0x23
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2B:
	RCALL SUBOPT_0x26
	ADIW R26,4
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2C:
	__PUTD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2D:
	ANDI R16,LOW(251)
	LDD  R30,Y+21
	ST   -Y,R30
	__GETW2SX 87
	__GETW1SX 89
	ICALL
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	__GETD1S 16
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x31:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x32:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x34:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x35:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	__GETD2S 9
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOVW R0,R30
	MOVW R30,R22
	RCALL __EEPROMWRW
	MOVW R30,R0
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
