#include <mega16a.h>
#include <alcd.h>
#include <delay.h>
#include <stdio.h>
#define ADC_VREF_TYPE 0x40
#define xtal 8000000
                                 
flash unsigned char keytbl[16]={0x77, 0x7B, 0x7D, 0xB7,
  0xBB, 0xBD, 0xD7, 0xDB,
   0xDD, 0xEB, 0xE7, 0xED,
    0x7e,0xBE, 0xDE, 0xEE}; 
 
  unsigned minute,hour,second; 
  unsigned ontime=99,offtime=99,onoff_timer=2;
  unsigned temp_ontime=99,temp_offtime=99;
  bit count_ontime_now=1,count_offtime_now=0,water_flag=0;  
  
 eeprom unsigned char t_max=30,t_min=20,light_range=80,co2_range=80; 
 eeprom float h_min=20;     
    

//DHT11 DEFINES
#define DHT11_PORT PORTA
#define DHT11_PORTPIN PORTA1
#define DHT11_DDR DDRA
#define DHT11_DDRPIN DDA1
#define DHT11_PINPORT PINA
#define DHT11_PIN PINA1

#define DHT11_INPUT_MODE() DHT11_DDR&=~(1<<DHT11_DDRPIN)
#define DHT11_OUTPUT_MODE() DHT11_DDR|=(1<<DHT11_DDRPIN)
#define DHT11_LOW() DHT11_PORT&=~(1<<DHT11_PORTPIN)
#define DHT11_HIGH() DHT11_PORT|=(1<<DHT11_PORTPIN)

#define DHTLIB_OK                               0
#define DHTLIB_ERROR_CHECKSUM					-1
#define DHTLIB_ERROR_TIMEOUT					-2


//END OF DHT11 DEFINES

    interrupt [TIM2_OVF] void timer2_ovf_isr(void)
    {
       if(onoff_timer==1 && second==59){
             if(  count_ontime_now==1 ){
               temp_ontime--;  
               water_flag=1;
                 
              } 
            
              if( count_offtime_now==1 ){
              temp_offtime--;  
               water_flag=0;
                 
              }  
                if(temp_ontime==0){ 
                   temp_ontime=ontime;
                   count_ontime_now=0;
                   count_offtime_now=1;
                   water_flag=0;
                   }
                     if(temp_offtime==0){      
                   temp_offtime=offtime;
                   count_ontime_now=1;
                   count_offtime_now=0;
                   water_flag=1;
                   } 
          }
            
    
    if(second==59){  //Real Time function Code
      second=0;
      if(minute==59){
      minute=0;
      if(hour==23)
      hour=0;
      else
      hour++;
      }
      else
      minute++;
      }
      else
      second++; //End of Real Time function Code 
      
         
     } 
  
  
 void setting(void);      
 void timer_setting(void);
 void system_setting(void);
 unsigned char get_keypad(void);   
 unsigned char get_number(void);        
 int read_dht11(int *temp,int *humidity); // DHT11 READ FUNC
  unsigned int read_adc(unsigned char adc_input)
  {
  ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
  delay_us(10);
  ADCSRA|=0x40;
  while ((ADCSRA & 0x10)==0);
  ADCSRA|=0x10;
  return ADCW;
  }
    
  void main(void){   
  unsigned char lcd_buff_1[17],lcd_buff_2[17];  
  
unsigned int co2;     
unsigned char count_loop=0;   
  
int temp=0;  
int humidity=0;
int status=0;

unsigned int ldr_light;

             
  DDRC=0X1F; // BUZZER & RELAYS
  
  lcd_init(16);
  lcd_putsf("Loading..."); 
  delay_ms(1);
  lcd_gotoxy(0,1);
  lcd_putsf(" ");     
   delay_ms(2000);
  ADMUX=ADC_VREF_TYPE & 0xff;
  ADCSRA=0x83;

  ASSR=0x08;//timer2
  TCCR2=0x05;
  TCNT2=0x00;
  OCR2=0x00;  
  TIMSK=0x40;
  #asm("sei") 
      
      //DHT11 needs 2000 ms to init
      delay_ms(2000);//Init DHT11 
      read_dht11(&temp,&humidity); 

     PORTC.4=1; //buzer test
     delay_ms(200);
     PORTC.4=0;
     lcd_clear();  

       while(1){  
       /*just for dht*/ 
       delay_ms(100);
       count_loop++;  
       if(count_loop==20){ //every 2second read DHT11
       status=read_dht11(&temp,&humidity); 
       count_loop=0;
       }            
       /*end of dht section in loop*/
       ldr_light=read_adc(2); 
       co2=read_adc(0);
      
      sprintf(lcd_buff_2,"H=%d%%",humidity,ldr_light); 
    
      sprintf(lcd_buff_1,"%d:%d:%d T=%d%cC ",hour,minute,second,(temp),223);
      
      lcd_gotoxy(0,0);
      lcd_puts(lcd_buff_1);
      delay_us(20);   
      lcd_gotoxy(0,1);
      lcd_puts(lcd_buff_2);
      delay_us(20); 
      
         
       
          
       
       
           if(humidity<h_min || water_flag==1 ){
               PORTC.0=1;
             } 
               else {
               PORTC.0=0;
              }
       
             
           
           if(co2> (unsigned int)(co2_range*10) ){
            lcd_gotoxy(11,1);
            lcd_putsf("G=H");
            
            PORTC.4=1; //buzzer on
             }
             else{  
             lcd_gotoxy(11,1);
             lcd_putsf("G=N");             
             PORTC.4=0;
             }
      
            
             if( ( (temp/2)>t_max) || (co2> (unsigned int)(co2_range*10)) ) {
               PORTC.1=1;  // fan on
             } 
               else {
               PORTC.1=0;
              }  
              
               if((temp/2)<t_min){ 
               PORTC.2=1; //heater on
             } 
               else {
               PORTC.2=0; // Heater off
              } 
              
              
             
             if(ldr_light>(unsigned int)(light_range*10)){
               PORTC.3=1;   
               lcd_gotoxy(7,1);
             lcd_putsf("L=N");
             } 
               else {
               PORTC.3=0;   
               lcd_gotoxy(7,1);
               lcd_putsf("L=Y");
              }    
             
             if(get_keypad()==13){
             setting();            
             } 
                    
             if(get_keypad()==14){  //timer setting          
              timer_setting();
             } 
             
              if(get_keypad()==15){  
             system_setting();
             } 
                     
             
            
         
 
         
       
             
       } 
  
       
   
   


}


  ////get keypad /
  unsigned char get_keypad(void){  
  unsigned char key, butnum;
  
  DDRB = 0x0f;
  PORTB = 0xf0;
  delay_us(5);
  key = PINB;
  DDRB = 0xf0;
  PORTB = 0x0f;
  delay_us(5);
  key = key | PINB;
  delay_us(5); 
 
    if (key != 0xff)
   {
     for (butnum=0; butnum<16; butnum++) {
     if (keytbl[butnum]==key) break;
    }
  
    butnum++;
    }
   else butnum=100;  
   return butnum;   
  } ////end get keypad f
  
  
  
  
  
  ///get num
  unsigned char get_number(void){  // get 2digit
   unsigned char z,x,y,buff[16];  // x is first num y is second and then our num=(x*10)+y 
   aval:
  do{
   x=get_keypad(); 
   if(x==10){x=0;}
   if(x>10){x=100;}
   }while(x==100);  
   
   do{
   z=get_keypad();
   }while(z !=100);
   
   delay_ms(40);
   lcd_gotoxy(0,1); 
   sprintf(buff,"%d",x);
   lcd_puts(buff);    
   delay_ms(40);
   
   do{
   y=get_keypad();
   if(y==10){y=0;}
   if(y>12){y=100;}
   }while(y==100); 
 
   do{
   z=get_keypad();
   }while(z !=100);     
     
   if(x<10){
    if(y<10){
    x*=10;
    x=x+y;
    } 
   }         
   lcd_gotoxy(0,1); 
   sprintf(buff,"%d",x);
   lcd_puts(buff); 
   
   while(1){  
   if(y==11){ return x;} //enter pressed
   if(y==12){ //corect pressed
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   goto aval;}  
   y=get_keypad();
   }  
  }   
  ///setting 
  void setting(void){
  unsigned char buff[16];
  lcd_clear();
  lcd_putsf("set system Time");
  lcd_gotoxy(5,1);
  sprintf(buff,"??:%d:%d",minute,second);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   hour=get_number();
   }while(hour>23);
   lcd_clear();  
    
  lcd_putsf("set system Time");
  lcd_gotoxy(5,1);
  sprintf(buff,"%d:??:%d",hour,second);
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   minute=get_number();
   }while(minute>59);
   lcd_clear(); 
   
 
   
   
  }  
  
  void timer_setting(void){
      unsigned char buff[16];   
       lcd_clear();
  lcd_putsf("ON OFF Timer? ");  
  delay_ms(1);    
  lcd_gotoxy(5,1);
  lcd_putsf("*ON=1 OFF=2*"); 
   
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   onoff_timer=get_number();
   }while(onoff_timer>2);
   lcd_clear();
    
     
   lcd_clear();
  lcd_putsf("ON Time Minute: ");  
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   ontime=get_number();
   }while(ontime>99);
   lcd_clear();  
    
  lcd_putsf("OFF Time Minute:");
  lcd_puts(buff); 
   do{  
   lcd_gotoxy(0,1);
   lcd_putsf("  ");
   offtime=get_number();
   }while(offtime>99);
   lcd_clear();  
   
   temp_ontime=ontime;
   temp_offtime=offtime; 
    if(onoff_timer==1)
     water_flag=1; 
     else
     water_flag=0; 
  } 
  
  void system_setting(void)
  {    
  unsigned char lcd_buff_1[17] ; 
  lcd_clear();    
   lcd_putsf("enter Max Temp ?");    
   t_max=get_number();  
   lcd_clear(); 
   sprintf(lcd_buff_1,"Max temp=%d C",t_max);
   lcd_puts(lcd_buff_1);  
   delay_ms(300);
   
   lcd_clear();    
   lcd_putsf("enter min Temp ?");    
   t_min=get_number();  
   lcd_clear(); 
   sprintf(lcd_buff_1,"min temp=%d C",t_min);
   lcd_puts(lcd_buff_1);  
   delay_ms(300);
   
   lcd_clear();
   lcd_putsf("enter min humid?");
   h_min=get_number(); 
   lcd_clear();
   sprintf(lcd_buff_1,"min humid=%.0f%%",h_min);
   lcd_puts(lcd_buff_1);  
   delay_ms(300); 
   
   lcd_clear();    
   lcd_putsf("enter Co2 range?");  
   delay_ms(1400);
   lcd_clear();    
   lcd_putsf("Co2=[1-99]");       
   co2_range=get_number();  
   lcd_clear(); 
   sprintf(lcd_buff_1,"Co2 Range=%d ",co2_range);
   lcd_puts(lcd_buff_1);  
   delay_ms(300); 
   
   lcd_clear();    
   lcd_putsf("enter Light range?");  
   delay_ms(1400);
   lcd_clear();    
   lcd_putsf("Light=[1-99]");       
   light_range=get_number();  
   lcd_clear(); 
   sprintf(lcd_buff_1,"light Range=%d ",light_range);
   lcd_puts(lcd_buff_1);  
   delay_ms(300);
  }
  
// read_dht11 functions
int read_dht11(int *temp,int *humidity){
unsigned char bytes[5];
unsigned char sum;
unsigned int bitcount=8;
unsigned int loopcount=0;
unsigned int byteid=0;
int i=0;
// EMPTY BUFFER
    for (i=0; i< 5; i++) bytes[i] = 0;
// REQUEST SAMPLE
    DHT11_OUTPUT_MODE();  
    DHT11_LOW();    
    delay_ms(20);
    DHT11_HIGH();
    delay_us(2);
    DHT11_INPUT_MODE();   
    DHT11_LOW();
    loopcount=0;    
    while(!(DHT11_PINPORT&(1<<DHT11_PIN))){ //pin is low
     delay_us(40);
     loopcount++;  
    }      
    if (loopcount>80) return DHTLIB_ERROR_TIMEOUT;
    loopcount=0;    
    while((DHT11_PINPORT&(1<<DHT11_PIN))){ //pin is high
     delay_us(1);
     loopcount++;
    }     
     if (loopcount>80) return DHTLIB_ERROR_TIMEOUT;
    for(i=0;i<40;i++){ 
    loopcount=0;    
    while(!(DHT11_PINPORT&(1<<DHT11_PIN))){}  
    while((DHT11_PINPORT&(1<<DHT11_PIN)) && loopcount<100){loopcount++;delay_us(1);}
    if(loopcount>15)
    bytes[byteid] |= (1 << bitcount);
     if (bitcount == 0)   // next byte?
        {
            bitcount = 7;    // restart at MSB
            byteid++;      // next byte!
        }
        else bitcount--; 
    } 
    *humidity    = bytes[0];
    *temp = bytes[2];
    sum = (bytes[0] + bytes[1]+ bytes[2]+ bytes[3])&0xff;  
    if (bytes[4] != sum) return DHTLIB_ERROR_CHECKSUM;  
    return DHTLIB_OK;
}